From 5717a02cc5076a59ab6aabbfd036555548f5df6d Mon Sep 17 00:00:00 2001
From: Gabriele Musco <gabmus@disroot.org>
Date: Sun, 26 Nov 2023 13:23:58 +0100
Subject: [PATCH 06/54] feat: boxed-list style for software page

---
 lact-gui/src/app/root_stack/info_page/mod.rs |   9 +-
 lact-gui/src/app/root_stack/mod.rs           |  23 +++-
 lact-gui/src/app/root_stack/software_page.rs | 121 +++++++------------
 lact-gui/ui/software_page.blp                |  25 ----
 4 files changed, 63 insertions(+), 115 deletions(-)
 delete mode 100644 lact-gui/ui/software_page.blp

diff --git a/lact-gui/src/app/root_stack/info_page/mod.rs b/lact-gui/src/app/root_stack/info_page/mod.rs
index cde7cfed..5037b80b 100644
--- a/lact-gui/src/app/root_stack/info_page/mod.rs
+++ b/lact-gui/src/app/root_stack/info_page/mod.rs
@@ -1,6 +1,6 @@
 mod vulkan_info;
 
-use super::LabelRow;
+use super::{list_clamp, LabelRow};
 use crate::app::page_section::PageSection;
 use gtk::prelude::*;
 use gtk::*;
@@ -98,12 +98,7 @@ impl InformationPage {
 
         vbox.append(&vulkan_container);
 
-        let clamp = libadwaita::Clamp::builder()
-            .maximum_size(600)
-            .margin_top(24)
-            .margin_bottom(24)
-            .child(&vbox)
-            .build();
+        let clamp = list_clamp(&vbox);
 
         let container = ScrolledWindow::builder()
             .hscrollbar_policy(PolicyType::Never)
diff --git a/lact-gui/src/app/root_stack/mod.rs b/lact-gui/src/app/root_stack/mod.rs
index 70ab1a3d..4734edc5 100644
--- a/lact-gui/src/app/root_stack/mod.rs
+++ b/lact-gui/src/app/root_stack/mod.rs
@@ -3,12 +3,11 @@ mod oc_page;
 mod software_page;
 mod thermals_page;
 
+use self::software_page::software_page;
 use gtk::{prelude::IsA, traits::GridExt, *};
-use libadwaita::prelude::ActionRowExt;
-
-use self::software_page::SoftwarePage;
 use info_page::InformationPage;
 use lact_client::schema::SystemInfo;
+use libadwaita::prelude::ActionRowExt;
 use oc_page::OcPage;
 use thermals_page::ThermalsPage;
 
@@ -36,7 +35,7 @@ impl RootStack {
 
         container.add_titled(&thermals_page.container, Some("thermals_page"), "Thermals");
 
-        let software_page = SoftwarePage::new(system_info, embedded_daemon);
+        let software_page = software_page(system_info, embedded_daemon);
         container.add_titled(&software_page, Some("software_page"), "Software");
 
         Self {
@@ -106,7 +105,23 @@ impl LabelRow {
         }
     }
 
+    pub fn new_with_content(title: &str, content: &str) -> Self {
+        let row = Self::new(title);
+        row.set_content(content);
+        row
+    }
+
     pub fn set_content(&self, content: &str) {
         self.content_label.set_label(content);
     }
 }
+
+pub fn list_clamp(child: &impl IsA<Widget>) -> libadwaita::Clamp {
+    libadwaita::Clamp::builder()
+        .maximum_size(600)
+        .margin_top(24)
+        .margin_bottom(24)
+        .child(child)
+        .valign(Align::Start)
+        .build()
+}
diff --git a/lact-gui/src/app/root_stack/software_page.rs b/lact-gui/src/app/root_stack/software_page.rs
index d215524b..366f91e9 100644
--- a/lact-gui/src/app/root_stack/software_page.rs
+++ b/lact-gui/src/app/root_stack/software_page.rs
@@ -1,83 +1,46 @@
+use super::{list_clamp, LabelRow};
 use crate::GUI_VERSION;
-use gtk::glib::{self, Object};
 use lact_client::schema::SystemInfo;
 
-glib::wrapper! {
-    pub struct SoftwarePage(ObjectSubclass<imp::SoftwarePage>)
-        @extends gtk::Box, gtk::Widget,
-        @implements gtk::Orientable, gtk::Accessible, gtk::Buildable;
-}
-
-impl SoftwarePage {
-    pub fn new(system_info: SystemInfo, embedded: bool) -> Self {
-        let mut daemon_version = format!("{}-{}", system_info.version, system_info.profile);
-        if embedded {
-            daemon_version.push_str("-embedded");
-        }
-
-        let gui_profile = if cfg!(debug_assertions) {
-            "debug"
-        } else {
-            "release"
-        };
-        let gui_version = format!("{GUI_VERSION}-{gui_profile}");
-
-        Object::builder()
-            .property("daemon-version", daemon_version)
-            .property("gui-version", gui_version)
-            .property("kernel-version", system_info.kernel_version)
-            .build()
-    }
-}
-
-mod imp {
-    #![allow(clippy::enum_variant_names)]
-    use crate::app::{info_row::InfoRow, page_section::PageSection};
-    use glib::Properties;
-    use gtk::{
-        glib::{self, subclass::InitializingObject},
-        prelude::*,
-        subclass::{
-            prelude::*,
-            widget::{CompositeTemplateClass, WidgetImpl},
-        },
-        CompositeTemplate,
-    };
-    use std::cell::RefCell;
-
-    #[derive(CompositeTemplate, Default, Properties)]
-    #[properties(wrapper_type = super::SoftwarePage)]
-    #[template(file = "ui/software_page.blp")]
-    pub struct SoftwarePage {
-        #[property(get, set)]
-        daemon_version: RefCell<String>,
-        #[property(get, set)]
-        gui_version: RefCell<String>,
-        #[property(get, set)]
-        kernel_version: RefCell<String>,
-    }
-
-    #[glib::object_subclass]
-    impl ObjectSubclass for SoftwarePage {
-        const NAME: &'static str = "SoftwarePage";
-        type Type = super::SoftwarePage;
-        type ParentType = gtk::Box;
-
-        fn class_init(class: &mut Self::Class) {
-            InfoRow::ensure_type();
-            PageSection::ensure_type();
-
-            class.bind_template();
-        }
-
-        fn instance_init(obj: &InitializingObject<Self>) {
-            obj.init_template();
-        }
-    }
-
-    #[glib::derived_properties]
-    impl ObjectImpl for SoftwarePage {}
-
-    impl WidgetImpl for SoftwarePage {}
-    impl BoxImpl for SoftwarePage {}
+pub fn software_page(system_info: SystemInfo, embedded: bool) -> gtk::ScrolledWindow {
+    let listbox = gtk::ListBox::builder()
+        .css_classes(["boxed-list"])
+        .selection_mode(gtk::SelectionMode::None)
+        .build();
+
+    listbox.append(
+        &LabelRow::new_with_content(
+            "LACT Daemon",
+            &format!(
+                "{}-{}{}",
+                system_info.version,
+                system_info.profile,
+                if embedded { "-embedded" } else { "" }
+            ),
+        )
+        .container,
+    );
+
+    listbox.append(
+        &LabelRow::new_with_content(
+            "LACT GUI",
+            &format!(
+                "{}-{}",
+                GUI_VERSION,
+                if cfg!(debug_assertions) {
+                    "debug"
+                } else {
+                    "release"
+                }
+            ),
+        )
+        .container,
+    );
+
+    listbox.append(&LabelRow::new_with_content("LACT GUI", &system_info.kernel_version).container);
+
+    gtk::ScrolledWindow::builder()
+        .hscrollbar_policy(gtk::PolicyType::Never)
+        .child(&list_clamp(&listbox))
+        .build()
 }
